'********************************************************************
'* POS.BAS - VB declarations for AIPLIB16.DLL and AIPLIB32.DLL      *
'********************************************************************

'********************************************************************
'* Device Class names used on PosOpen                               *
'********************************************************************

Global Const PosAlarm = "PosAlarm"
Global Const PosDrawer = "PosDrawer"
Global Const PosDisplay = "PosDisplay"
Global Const PosKeyboard = "PosKeyboard"
Global Const PosMsr = "PosMsr"
Global Const PosNvram = "PosNvram"
Global Const PosPower = "PosPower"
Global Const PosPrinter = "PosPrinter"
Global Const PosRs232 = "PosRs232"
Global Const PosScale = "PosScale"
Global Const PosScanner = "PosScanner"
Global Const PosTouch = "PosTouch"
Global Const PosInternal = "PosInternal"


'********************************************************************
'* Request values used with PosIOCtl                                *
'********************************************************************

Global Const POS_TILL_OPEN_TILL = (5400 + 1)
Global Const POS_ALARM_SILENCE_ALARM = (5400 + 2)
Global Const POS_ALARM_SOUND_ALARM = (5400 + 3)

Global Const POS_DSP_CLEAR_SCREEN = (4400 + 1)
Global Const POS_DSP_DEFINE_CHARACTERS = (4400 + 2)

Global Const POS_KBD_DISABLE_POS_FUNCTIONS = (4700 + 1)
Global Const POS_KBD_ENABLE_POS_FUNCTIONS = (4700 + 2)
Global Const POS_KBD_SILENCE_TONE = (4700 + 4)
Global Const POS_KBD_SOUND_TONE = (4700 + 5)
Global Const POS_KBD_SET_TYPEMATIC_OFF = (4700 + 6)
Global Const POS_KBD_SET_TYPEMATIC_ON = (4700 + 7)
Global Const POS_KBD_DISABLE_HOT_KEYS = (4700 + 8)
Global Const POS_KBD_ENABLE_HOT_KEYS = (4700 + 9)
Global Const POS_KBD_DISABLE_NUM_LOCK = (4700 + 10)
Global Const POS_KBD_ENABLE_NUM_LOCK = (4700 + 11)
Global Const POS_KBD_DISABLE_SCROLL_LOCK = (4700 + 12)
Global Const POS_KBD_ENABLE_SCROLL_LOCK = (4700 + 13)
Global Const POS_KBD_SET_NUM_LOCK_OFF = (4700 + 15)
Global Const POS_KBD_SET_NUM_LOCK_ON = (4700 + 16)
Global Const POS_KBD_SET_SCROLL_LOCK_OFF = (4700 + 17)
Global Const POS_KBD_SET_SCROLL_LOCK_ON = (4700 + 18)

Global Const POS_POWER_OFF = (6400 + 1)
Global Const POS_POWER_ON = (6400 + 2)
Global Const POS_POWER_SET_ALARM = (6400 + 3)

Global Const POS_PRN_DISABLE_DI_PRINTING = (4900 + 1)
Global Const POS_PRN_ENABLE_DI_PRINTING = (4900 + 2)
Global Const POS_PRN_RESUME_PRINTING = (4900 + 3)
Global Const POS_PRN_RETRY_PRINTING = (4900 + 4)
Global Const POS_PRN_DISCARD_DATA = (4900 + 5)
Global Const POS_PRN_DISABLE_FISCAL_PRINTING = (4900 + 6)
Global Const POS_PRN_ENABLE_FISCAL_PRINTING = (4900 + 7)
Global Const POS_PRN_RESET_PRINTER = (4900 + 8)
Global Const POS_PRN_DEFINE_CHARACTERS = (4900 + 9)

Global Const POS_SCAN_DISCARD_DATA = (5700 + 1)

Global Const POS_RS232_SEND_BREAK = (5900 + 1)

Global Const POS_SCALE_ZERO_SCALE = (6100 + 1)
Global Const POS_SCALE_CLEAR_SCREEN = (6100 + 2)

Global Const POS_TOUCH_SILENCE_TONE = (6700 + 1)
Global Const POS_TOUCH_SOUND_TONE = (6700 + 2)

Global Const POS_SYS_ACQUIRE_DEVICE = (300 + 1)
Global Const POS_SYS_GET_VALUES = (300 + 2)
Global Const POS_SYS_LOCK_DEVICE = (300 + 3)
Global Const POS_SYS_RELEASE_DEVICE = (300 + 4)
Global Const POS_SYS_SET_VALUES = (300 + 5)
Global Const POS_SYS_UNLOCK_DEVICE = (300 + 6)


'********************************************************************
'* Type Definitions                                                 *
'********************************************************************

Type PosArg
  name As Long
  value As Long
End Type


'********************************************************************
'* Resource identifiers used in the 'name' field of the PosArg type.*
'********************************************************************

Global Const PosNslotNumber = 0
Global Const PosNportNumber = 1
Global Const PosNdeviceNumber = 2
Global Const PosNqueueHandle = 3
Global Const PosNreadTimeout = 4
Global Const PosNpulseWidth = 5
Global Const PosNtillStatus = 6
Global Const PosNdisplayCursor = 7
Global Const PosNdisplayLightsOn = 8
Global Const PosNpixelX = 9
Global Const PosNpixelY = 10
Global Const PosNcharSize = 11
Global Const PosNdisplayMode = 12
Global Const PosNdisplayUpsideDown = 13
Global Const PosNkeyboardClick = 14
Global Const PosNkeyLock = 15
Global Const PosNkeyboardLightsOn = 16
Global Const PosNscanCodeSet = 17
Global Const PosNtoneFreq = 18
Global Const PosNtoneDuration = 19
Global Const PosNtoneVolume = 20
Global Const PosNdoubleKey01 = 21
Global Const PosNdoubleKey02 = 22
Global Const PosNdoubleKey03 = 23
Global Const PosNdoubleKey04 = 24
Global Const PosNdoubleKey05 = 25
Global Const PosNdoubleKey06 = 26
Global Const PosNdoubleKey07 = 27
Global Const PosNdoubleKey08 = 28
Global Const PosNdoubleKey09 = 29
Global Const PosNdoubleKey10 = 30
Global Const PosNdoubleKey11 = 31
Global Const PosNdoubleKey12 = 32
Global Const PosNdoubleKey13 = 33
Global Const PosNdoubleKey14 = 34
Global Const PosNdoubleKey15 = 35
Global Const PosNdoubleKey16 = 36
Global Const PosNdoubleKey17 = 37
Global Const PosNdoubleKey18 = 38
Global Const PosNdoubleKey19 = 39
Global Const PosNdoubleKey20 = 40
Global Const PosNdoubleKey21 = 41
Global Const PosNdoubleKey22 = 42
Global Const PosNdoubleKey23 = 43
Global Const PosNdoubleKey24 = 44
Global Const PosNdoubleKey25 = 45
Global Const PosNdoubleKey26 = 46
Global Const PosNdoubleKey27 = 47
Global Const PosNdoubleKey28 = 48
Global Const PosNdoubleKey29 = 49
Global Const PosNdoubleKey30 = 50
Global Const PosNdoubleKey31 = 51
Global Const PosNdoubleKey32 = 52
Global Const PosNdoubleKey33 = 53
Global Const PosNdoubleKey34 = 54
Global Const PosNdoubleKey35 = 55
Global Const PosNdoubleKey36 = 56
Global Const PosNdoubleKey37 = 57
Global Const PosNdoubleKey38 = 58
Global Const PosNdoubleKey39 = 59
Global Const PosNdoubleKey40 = 60
Global Const PosNdoubleKey41 = 61
Global Const PosNdoubleKey42 = 62
Global Const PosNdoubleKey43 = 63
Global Const PosNdoubleKey44 = 64
Global Const PosNdoubleKey45 = 65
Global Const PosNdoubleKey46 = 66
Global Const PosNdoubleKey47 = 67
Global Const PosNdoubleKey48 = 68
Global Const PosNdoubleKey49 = 69
Global Const PosNdoubleKey50 = 70
Global Const PosNdoubleKey51 = 71
Global Const PosNdoubleKey52 = 72
Global Const PosNdoubleKey53 = 73
Global Const PosNdoubleKey54 = 74
Global Const PosNdoubleKey55 = 75
Global Const PosNdoubleKey56 = 76
Global Const PosNdoubleKey57 = 77
Global Const PosNdoubleKey58 = 78
Global Const PosNdoubleKey59 = 79
Global Const PosNdoubleKey60 = 80
Global Const PosNfatFingerTimeOut = 81
Global Const PosNnumpadLocation = 82
Global Const PosNnumpadStyle = 83
Global Const PosNnumpadZero = 84
Global Const PosNtypematicDelay = 85
Global Const PosNtypematicFreq = 86
Global Const PosNalarmStatus = 87
Global Const PosNbarCodes1 = 88
Global Const PosNbarCodes2 = 89
Global Const PosNbarCodes3 = 90
Global Const PosNbarCodes4 = 91
Global Const PosNbeepFreq = 92
Global Const PosNbeepLength = 93
Global Const PosNbeepState = 94
Global Const PosNbeepVolume = 95
Global Const PosNblinkLength = 96
Global Const PosNblock1Type = 97
Global Const PosNblock2Type = 98
Global Const PosNblock3Type = 99
Global Const PosNblockReadMode = 100
Global Const PosNbVolSwitchState = 101
Global Const PosNcheckModulo = 102
Global Const PosNcode128ScansPerRead = 103
Global Const PosNcode39ScansPerRead = 104
Global Const PosNdReadTimeout = 105
Global Const PosNdecodeAlgorithm = 106
Global Const PosNdTouchMode = 107
Global Const PosNiTFLength1 = 108
Global Const PosNiTFLength2 = 109
Global Const PosNiTFScansPerRead = 110
Global Const PosNjANTwoLabelDecode = 111
Global Const PosNlabelsQueued = 112
Global Const PosNlaserTimeout = 113
Global Const PosNmotorTimeout = 114
Global Const PosNlaserSwitchState = 115
Global Const PosNqueueAllLabels = 116
Global Const PosNscansPerRead = 117
Global Const PosNeAN13ScansPerRead = 118
Global Const PosNeAN8ScansPerRead = 119
Global Const PosNuPCAScansPerRead = 120
Global Const PosNuPCDScansPerRead = 121
Global Const PosNuPCEScansPerRead = 122
Global Const PosNstoreScansPerRead = 123
Global Const PosNtwoLabelFlagPair1 = 124
Global Const PosNtwoLabelFlagPair2 = 125
Global Const PosNtwoLabelFlagPair3 = 126
Global Const PosNtwoLabelFlagPair4 = 127
Global Const PosNuPCExpansion = 128
Global Const PosNverifyPriceChk = 129
Global Const PosNrs232Status = 130
Global Const PosNlineMode = 131
Global Const PosNbaudRate = 132
Global Const PosNstopBits = 133
Global Const PosNparity = 134
Global Const PosNdataBits = 135
Global Const PosNtimeoutChar = 136
Global Const PosNDIWidth = 137
Global Const PosNfeedDirection = 138
Global Const PosNfiscalCountry = 139
Global Const PosNfiscalNotify = 140
Global Const PosNfiscalPLDStatus = 141
Global Const PosNfiscalVersion = 142
Global Const PosNheadParkedPosition = 143
Global Const PosNinterleaved = 144
Global Const PosNlineFeedCR = 145
Global Const PosNlineFeedDI = 146
Global Const PosNlineFeedSJ = 147
Global Const PosNprintMode = 148
Global Const PosNprintStation = 149
Global Const PosNprintStatus = 150
Global Const PosNrawPrintStatus = 151
Global Const PosNresumeString = 152
Global Const PosNretryString = 153
Global Const PosNnvramCursor = 154
Global Const PosNnvramMode = 155
Global Const PosNnvramSize = 156
Global Const PosNdisplayRequired = 157
Global Const PosNoperMode = 158
Global Const PosNvibrationFilter = 159
Global Const PosNweightMode = 160
Global Const PosNzeroIndState = 161
Global Const PosNzeroRetState = 162
Global Const PosNpowerAlarm = 163
Global Const PosNtouchBackLightOnEvent = 164
Global Const PosNtouchClickVolume = 165
Global Const PosNtouchContrast = 166
Global Const PosNtouchEntryClick = 167
Global Const PosNtouchExitClick = 168
Global Const PosNtouchMaxX = 169
Global Const PosNtouchMaxY = 170
Global Const PosNtouchMode = 171
Global Const PosNtouchScreenSaverTime = 172
Global Const PosNtouchToneDuration = 173
Global Const PosNtouchToneFreq = 174
Global Const PosNtouchToneVolume = 175
Global Const PosNdiOrientation   = 176
Global Const PosNleftMarginCR    = 177
Global Const PosNprintAlignment  = 178
Global Const PosNprintFeatures   = 179
Global Const PosNprintStatus2    = 180


'********************************************************************
'* Interface calls into the POS library.                            *
'********************************************************************

#If Win32 Then
    Declare Function PosClose Lib "AIPLIB32.DLL" Alias "PosClose" (ByVal devdes&) As Long
    Declare Function PosErrno Lib "AIPLIB32.DLL" Alias "PosErrno" () As Long
    Declare Function PosInitialize Lib "AIPLIB32.DLL" Alias "PosInitializeVB" (ByVal appname$, ByVal file$, Reserved_1, Reserved_2, args As PosArg, ByVal nargs&) As Long
    Declare Function PosIOCtl Lib "AIPLIB32.DLL" Alias "PosIOCtlVB" (ByVal devdes&, ByVal request&, args As PosArg, ByVal nargs&) As Long
    Declare Function PosOpen Lib "AIPLIB32.DLL" Alias "PosOpenVB" (ByVal devname$, ByVal devclass$, args As PosArg, ByVal nargs&) As Long
    Declare Function PosRead Lib "AIPLIB32.DLL" Alias "PosRead" (ByVal devdes&, ByVal buf$, ByVal nbyte&) As Long
    Declare Function PosWrite Lib "AIPLIB32.DLL" Alias "PosWrite" (ByVal devdes&, ByVal buf$, ByVal nbyte&) As Long
#Else
    Declare Function PosClose Lib "AIPLIB16.DLL" Alias "PosClose" (ByVal devdes%) As Integer
    Declare Function PosErrno Lib "AIPLIB16.DLL" Alias "PosErrno" () As Integer
    Declare Function PosInitialize Lib "AIPLIB16.DLL" Alias "PosInitializeVB" (ByVal appname$, ByVal file$, Reserved_1, Reserved_2, args As PosArg, ByVal nargs%) As Integer
    Declare Function PosIOCtl Lib "AIPLIB16.DLL" Alias "PosIOCtlVB" (ByVal devdes%, ByVal request%, args As PosArg, ByVal nargs%) As Integer
    Declare Function PosOpen Lib "AIPLIB16.DLL" Alias "PosOpenVB" (ByVal devname$, ByVal devclass$, args As PosArg, ByVal nargs%) As Integer
    Declare Function PosRead Lib "AIPLIB16.DLL" Alias "PosRead" (ByVal devdes%, ByVal buf$, ByVal nbyte%) As Integer
    Declare Function PosWrite Lib "AIPLIB16.DLL" Alias "PosWrite" (ByVal devdes%, ByVal buf$, ByVal nbyte%) As Integer
#End If


'********************************************************************
'* Helper routines                                                  *
'********************************************************************

#If Win32 Then
    Function PosGetValues&(device As Integer, args As PosArg, nargs As Integer)
        PosGetValues& = POSIOCTL(device, POS_SYS_GET_VALUES, args, nargs)
    End Function

    Function PosNumber&(arr() As PosArg)
        PosNumber& = UBound(arr) - LBound(arr) + 1
    End Function

    Sub PosSetArg(arg As PosArg, rname As String, value As Long)
        arg.name = rname
        arg.value = value
    End Sub

    Function PosSetValues&(device As Integer, args As PosArg, nargs As Integer)
        PosSetValues& = POSIOCTL(device, POS_SYS_SET_VALUES, args, nargs)
    End Function
#Else
    Function PosGetValues%(device As Integer, args As PosArg, nargs As Integer)
        PosGetValues% = POSIOCTL(device, POS_SYS_GET_VALUES, args, nargs)
    End Function

    Function PosNumber%(arr() As PosArg)
        PosNumber% = UBound(arr) - LBound(arr) + 1
    End Function

    Sub PosSetArg(arg As PosArg, rname As Long, value As Long)
        arg.name = rname
        arg.value = value
    End Sub

    Function PosSetValues%(device As Integer, args As PosArg, nargs As Integer)
        PosSetValues% = POSIOCTL(device, POS_SYS_SET_VALUES, args, nargs)
    End Function
#End If



